import { IpFilterOptions, IpCallback, IpList, IpResult } from './IpTypes';
export declare class IpFilter {
    private settings;
    private getIps;
    private logger;
    private detectIp;
    constructor(ips: IpList | IpCallback, opts?: IpFilterOptions);
    /**
     * Compile "proxy trust" value to function. (from express)
     *
     * @param  {Boolean|String|Number|Array|Function} val
     * @return {Function}
     * @api private
     */
    private compileTrust;
    private testExplicitIp;
    private testCidrBlock;
    private testRange;
    private testIp;
    private matchClientIp;
    private error;
    get middleware(): (req: any, _res: any, next: any) => void;
    checkIP(req: any): IpResult;
}
