/// <reference types="node" />
import { IncomingMessage } from 'http';
export type Ip = string;
export type CidrRange = string;
export type Route = string;
export type StartEndIpRange = Ip[];
export type IpRange = CidrRange | StartEndIpRange;
export type IpList = (Ip | IpRange)[];
export type IPListAsync = Promise<IpList>;
export type IpCallback = () => IpList;
export interface IpResult {
    status: boolean;
    ip: Ip;
    msg?: string;
}
export interface IpFilterOptions {
    detectIp?: (request: IncomingMessage) => Ip;
    excluding?: Route[];
    log?: boolean;
    logLevel?: 'all' | 'deny' | 'allow';
    logF?: (message: string) => void;
    mode?: 'deny' | 'allow';
    trustProxy?: any;
    cidr?: boolean;
    allowedHeaders?: any[];
    allowPrivateIPs?: boolean;
}
